################################################
###Please use "qsub jma.sh" to submit to cluster
###############################################

#!/bin/bash
###
#PBS -S /bin/bash
#PBS -N JumpDb_builder
#PBS -d /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb
#PBS -e /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/errfile.txt
#PBS -o /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/outfile.txt
###PBS -M xsu1@mdanderson.org 
#PBS -q batch
#PBS -l nodes=1:ppn=1

#####################
##your command here##
#####################

##for gib virus reference genome
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -fr gibVirus.fa -oa gibVirus.fa.bin -st illumina -assignQual 40
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikJump -ia gibVirus.fa.bin -out gibVirus.JumpDb -hs 15 -mhp 100 -km

##version-0.89 and for combined hg19Virus reference genome
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -fr hg19Virus.fa -oa hg19Virus.fa.bin -st illumina -assignQual 40
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikJump -ia hg19Virus.fa.bin -out hg19Virus.JumpDb -hs 15 -mhp 100 -km

##for hg19 reference genome
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -fr hg19.fa -oa hg19.fa.bin -st illumina -assignQual 40
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikJump -ia hg19.fa.bin -out hg19.JumpDb -hs 15 -mhp 100 -km

