#!/bin/bash
###
#PBS -S /bin/bash
#PBS -N L526401A_gDNA
#PBS -d /RIS/home/xsu1/VirusSeq/L526401A
#PBS -e /RIS/home/xsu1/VirusSeq/L526401A/errfile.txt
#PBS -o /RIS/home/xsu1/VirusSeq/L526401A/outfile_gDNA.txt
#PBS -q medium
#PBS -V
#PBS -l nodes=1:ppn=14

#Mosaik alignment
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -q /RIS/home/xsu1/VirusSeq/L526401A/L526401A_1.fq.gz -q2 /RIS/home/xsu1/VirusSeq/L526401A/L526401A_2.fq.gz -out L526401A.bin -st illumina

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAligner -in L526401A.bin -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.fa.bin -out L526401A.bin.aligned -hs 15 -mmp 0.06 -mmal -minp 0.5 -act 25 -mhp 100 -m unique -a all -j /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.JumpDb -km -pm -p 14

###Spanner
/RIS/home/xsu1/VirusSeq/Mosaik_bin/Spanner --scan --infile L526401A.bin.aligned --outdir SV_gDNA
/RIS/home/xsu1/VirusSeq/Mosaik_bin/Spanner --build --infile L526401A.bin.aligned --outdir SV_gDNA -f SV_gDNA/MSK.stats -a /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/Spanner_anchor_hg19Virus.txt -t

