#!/bin/bash
###
#PBS -S /bin/bash
#PBS -N L526401A_SE_gDNA
#PBS -d /RIS/home/xsu1/VirusSeq/L526401A
#PBS -e /RIS/home/xsu1/VirusSeq/L526401A/errfile.txt
#PBS -o /RIS/home/xsu1/VirusSeq/L526401A/outfile_SE_gDNA.txt
#PBS -q medium
#PBS -V
#PBS -l nodes=1:ppn=14


##first mate
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -q /RIS/home/xsu1/VirusSeq/L526401A/L526401A_1.fq.gz -out L526401A_1.bin -st illumina
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAligner -in L526401A_1.bin -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.fa.bin -out L526401A_1.bin.aligned -hs 15 -mmp 0.06 -mmal -minp 0.5 -act 25 -mhp 100 -m unique -j /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.JumpDb -p 14 -km -pm
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikSort -in L526401A_1.bin.aligned -out L526401A_1.bin.aligned.sorted -u


##second mate
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -q /RIS/home/xsu1/VirusSeq/L526401A/L526401A_2.fq.gz -out L526401A_2.bin -st illumina
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAligner -in L526401A_2.bin -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.fa.bin -out L526401A_2.bin.aligned -hs 15 -mmp 0.06 -mmal -minp 0.5 -act 25 -mhp 100 -m unique -j /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19Virus.JumpDb -p 14 -km -pm
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikSort -in L526401A_2.bin.aligned -out L526401A_2.bin.aligned.sorted -u


##merge two files
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikMerge -in L526401A_1.bin.aligned.sorted -in L526401A_2.bin.aligned.sorted -out L526401A_SE.bin.aligned.sorted
/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikText -in L526401A_SE.bin.aligned.sorted -axt L526401A_SE.bin.aligned.sorted.axt

