#!/bin/bash
###
#PBS -S /bin/bash
#PBS -N L526401A_Virus
#PBS -d /RIS/home/xsu1/VirusSeq/L526401A
#PBS -e /RIS/home/xsu1/VirusSeq/L526401A/errfile_Virus.txt
#PBS -o /RIS/home/xsu1/VirusSeq/L526401A/L526401A_Virus.txt
#PBS -q medium
#PBS -V
#PBS -l nodes=1:ppn=14


/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -q /RIS/home/xsu1/VirusSeq/L526401A/L526401A_1.fq.gz -q2 /RIS/home/xsu1/VirusSeq/L526401A/L526401A_2.fq.gz -out L526401A_Virus.bin -st illumina

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAligner -in L526401A_Virus.bin -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19.fa.bin -out L526401A_Virus.bin.aligned -hs 15 -mmp 0.1 -mmal -minp 0.5 -act 25 -mhp 100 -m unique -j /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/hg19.JumpDb -p 14 -km -pm -rur L526401A_Unalg.fq


##Virus profiling

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikBuild -q L526401A_Unalg.fq -out L526401A_Virus.bin -st illumina

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAligner -in L526401A_Virus.bin -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/gibVirus.fa.bin -out L526401A_Virus.bin.aligned -hs 15 -mmp 0.15 -act 25 -mhp 100 -m all -j /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/gibVirus.JumpDb -p 14 -km -pm

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikSort -in L526401A_Virus.bin.aligned -out L526401A_Virus.bin.aligned.sorted

/RIS/home/xsu1/VirusSeq/Mosaik_bin/MosaikAssembler -in L526401A_Virus.bin.aligned.sorted -ia /RIS/home/xsu1/VirusSeq/Mosaik_JumpDb/gibVirus.fa.bin -out Gig/L526401A_Virus.bin.aligned.sorted.assembled -f ace >L526401A_VirusLog.txt


perl /RIS/home/xsu1/VirusSeq/VirusSeq_Script/VirusSeq_Detection.pl L526401A_VirusLog.txt 1000 L526401A_VirusName.txt

